/*  


ͻ
 Programa  RelSC5EL  Autor Manoel e Jairo       Data   11/08/14   
͹
Descricao  Imprime Pedidos de venda com estoque liberado.             
                                                                      
͹
Modulo    | SIGAEST  | USO | Especifico do SIGAEST                     
ͼ


*/


#Include "PROTHEUS.CH"
#Include "RWMAKE.CH"               
#Include "REPORT.CH"

User Function RelSC5EL()

	Local cPerg     := "RelSC5EL"
	PRIVATE cData   := dtoc(Date())
	PRIVATE cTime   := time()
	PRIVATE cTitulo := "Impresso - Relatrio Pedido de Venda com Estoque Liberado"
	PRIVATE nPag    := 0
	PRIVATE oPrn, oArial07, oArial09B ,oArial14B
	PRIVATE nColMax := 1750                  


   
	DEFINE FONT oArial10 NAME  "Arial"  SIZE 0,10 OF oPrn
	DEFINE FONT oArial20 NAME  "Arial"  SIZE 0,16 OF oPrn
	DEFINE FONT oArial10B NAME "Arial" SIZE 0,10 OF oPrn BOLD
	DEFINE FONT oArial12B NAME "Arial" SIZE 0,12 OF oPrn BOLD
   DEFINE FONT oArial12 NAME "Arial" SIZE 0,12 OF oPrn 
	DEFINE FONT oArial20B NAME "Arial" SIZE 0,16 OF oPrn BOLD
                                                        
  
   
	CriaSX1(cPerg)
	If !Pergunte(cPerg,.T.)
		Return
	EndIf
   
	Processa({||GeraDados(mv_Par01,mv_Par02,mv_Par03,mv_Par04,mv_Par05,mv_Par06,mv_Par07,mv_Par08,mv_Par09,mv_Par10)}, "Aguarde... Processando.")
Return
   
Static Function GeraDados(PDIn,PDFn,ClIn,LjIn,ClFn,LjFn,ProIn,ProFn,DtLIn,DtLFn)
	Local AlSC9 := GetNextAlias()
	Local cPerg := "RelSC5EL"
	Local cSQL  := ""
	Local nX := 0
	Private aDados := {}

	
	If !Empty(PDIn)
		cSQL += " AND C9_PEDIDO >= '"+PDIn+"'"
	EndIf

	If !Empty(PDFn)
		cSQL += " AND C9_PEDIDO <= '"+PDFn+"'"
	EndIf

	If !Empty(ClIn)
		cSQL += " and C9_CLIENTE >= '"+ClIn+"'"
	EndIf

	If !Empty(LjIn)
		cSQL += " and C9_LOJA >= '"+LjIn+"'"
	EndIf

	If !Empty(ClFn)
		cSQL += " and C9_CLIENTE <= '"+ClFn+"'"
	EndIf

	If !Empty(LjFn)
		cSQL += " and C9_LOJA <= '"+LjFn+"'"
	EndIf

	If !Empty(ProIn)
		cSQL += " AND DC_PRODUTO >= '"+ProIn+"'"
	EndIf

	If !Empty(ProFn)
		cSQL += " AND DC_PRODUTO <= '"+ProFn+"'"
	EndIf

	If !Empty(DtLIn)
		cSQL += " AND C9_DATALIB >= '" +DtoS(DtLIn)+"'"
	EndIf

	If !Empty(DtLFn)
		cSQL += " AND C9_DATALIB <= '" +DtoS(DtLFn)+"'"
	EndIf

	cSQL := "%"+cSQL+"%"

	// Embedded SQL
	BeginSQL Alias AlSC9
		Column B8_DTVALID as Date
   	Column C9_DATALIB as Date  
   	
		SELECT SC9.C9_FILIAL, SC9.C9_PEDIDO, SC9.C9_CLIENTE,  SC9.C9_XNCLIEN, SC9.C9_LOJA, SC9.C9_DATALIB, SC5.C5_XEXP, SC5.C5_TRANSP, SC5.C5_TPFRETE,SA4.A4_NOME,
		       SC9.C9_ITEM,  SC9.C9_PRODUTO,  SB1.B1_DESC, SDC.DC_QUANT, SC9.C9_LOCAL, SDC.DC_LOCALIZ, SDC.DC_NUMSERI,
		       SDC.DC_LOTECTL, SB8.B8_DTVALID
            
		FROM %Table:SC9% SC9 
		
		LEFT JOIN %Table:SDC% SDC ON SDC.DC_FILIAL = SC9.C9_FILIAL  AND SDC.DC_PRODUTO = SC9.C9_PRODUTO AND
		                             SDC.DC_PEDIDO = SC9.C9_PEDIDO  AND SDC.%NotDel%
		LEFT JOIN %Table:SB1% SB1 ON SB1.B1_COD    = SDC.DC_PRODUTO AND
		                             SB1.B1_FILIAL = '01' AND SB1.%NotDel%
		LEFT JOIN %Table:SB8% SB8 ON SB8.B8_FILIAL = SC9.C9_FILIAL  AND
		                             SB8.B8_LOTECTL= SDC.DC_LOTECTL AND
		                             SB8.%NotDel%
		LEFT JOIN %Table:SC5% SC5 ON SC5.C5_FILIAL = SC9.C9_FILIAL  AND
		                             SC5.C5_NUM = SC9.C9_PEDIDO AND
		                             SC5.C5_CLIENT = SC9.C9_CLIENTE AND
		                             SC5.%NotDel%
		LEFT JOIN %Table:SA4% SA4 ON SA4.A4_COD    = SC5.C5_TRANSP AND
		                             SA4.A4_FILIAL = '01' AND SA4.%NotDel%
		
		WHERE  SC9.%NotDel%
               
		%Exp:cSQL%
               
		ORDER BY C9_FILIAL, C9_PEDIDO, C9_ITEM 
	EndSQL

	(AlSC9)->(dbGoTop())
	
	While !(AlSC9)->(EOF())
		nX := aScan(aDados, {|x| x[2] = (AlSC9)->C9_PEDIDO})
		
		If nX = 0
			aAdd(aDados, {(AlSC9)->C9_FILIAL,; //[1]
				          (AlSC9)->C9_PEDIDO,;  //[2] 
				          (AlSC9)->C9_CLIENTE,; //[3]
				          (AlSC9)->C9_XNCLIEN,; //[4]
				          (AlSC9)->C9_LOJA,;    //[5]
				          DTOC((AlSC9)->C9_DATALIB),; //[6]
				          Posicione("SC5",1,xFilial("SC5")+(AlSC9)->C9_PEDIDO,"C5_XEXP"),; //[7]
				          (AlSC9)->A4_NOME,;    //[8]// IIf(X=X,"a",IIF(X<>Y,"H",IIf(a=a,"g","f")))
                      iif((AlSC9)->C5_TPFRETE="T","TERCEIROS",iif((AlSC9)->C5_TPFRETE="C","CIF",iif((AlSC9)->C5_TPFRETE="F","FOB","SEM FRETE"))),; //[9]
				          {}})
				          nX := Len(aDados)
	  
			EndIf		          
	 
				          	
		aAdd(aDados[nX][10], {(AlSC9)->C9_ITEM,;                            //[10][1] ITEM
		                     (AlSC9)->C9_PRODUTO,;                           //[10][2] Codigo
		                     (AlSC9)->B1_DESC,;                              //[10][3] Descrio
		                     Transform((AlSC9)->DC_QUANT, "@E 99,9999"),;    //[10][4] Quantidade
		                     Transform((AlSC9)->C9_LOCAL, "@E 9999"),;       //[10][5] Armazem
		                     (AlSC9)->DC_LOCALIZ,;                           //[10][6] Endereo
		                     (AlSC9)->DC_NUMSERI,;                           //[10][7] NSerie
		                     Transform((AlSC9)->DC_LOTECTL, "@E 9999999"),;  //[10][8] Lote
		                     DTOC((AlSC9)->B8_DTVALID)})                     //[10][9] VDLote

		(AlSC9)->(dbSkip())
	EndDo
	
	Processa({||Imprime()},"Aguarde")
Return

Static Function Imprime()
	Local I := N := 0
	Local nCont  := 0
	Local nLin   := 560
	
//	oPrn := FWMSPrinter():New("RelSC5EL")
   oPrn := FWMsPrinter():New("RelSC5EL",6,.T., ,.T., , , , ,.F., , .T., )
   oPrn:SetLandscape()
   oPrn:SetPaperSize(9)

	For I := 1 To Len(aDados)
		Filial  := aDados[I][1]
  		Pedido  := aDados[I][2]
	  	Cliente := aDados[I][3]
  		Nome    := aDados[I][4]
  		Loja    := aDados[I][5]
		DataLib := aDados[I][6]
		cObs    := aDados[I][7]
		aObs    := Quebra() 
		Transp  := aDados[I][8]  
		Frete   := aDados[I][9]
		meucabec()
		
		If nLin > 2000
			oPrn:EndPage()
			meucabec()
			nLin := 560
		Endif
		
		//*********************CABECALHO DOS ITENS *********************************
	
		oPrn:Say(nLin,0110,"Cdigo",oArial10b)
		oPrn:Say(nLin,0320,"Item",oArial10b)
		oPrn:Say(nLin,0420,"Descrio",oArial10b)
		oPrn:Say(nLin,1480,"Quantidade",oArial10b)
		oPrn:Say(nLin,1690,"Arm",oArial10b)
		oPrn:Say(nLin,1760,"Endereo",oArial10b)
		oPrn:Say(nLin,1980,"N de Srie",oArial10b)
		oPrn:Say(nLin,2270,"Lote",oArial10b)
		oPrn:Say(nLin,2740,"Validade Lote",oArial10b)
	
  		nLin += 50     
		For N := 1 to Len(aDados[I][10])
		   oPrn:Say(nLin,0050,PadL(N,2,"0"),oArial10)
			oPrn:Say(nLin,0110,aDados[I][10][N][2],oArial10)
			oPrn:Say(nLin,0320,aDados[I][10][N][1],oArial10)
			oPrn:Say(nLin,0420,aDados[I][10][N][3],oArial10)
			oPrn:Say(nLin,1480,aDados[I][10][N][4],oArial10)
		 	oPrn:Say(nLin,1690,aDados[I][10][N][5],oArial10)
			oPrn:Say(nLin,1760,aDados[I][10][N][6],oArial10)
			oPrn:Say(nLin,1980,aDados[I][10][N][7],oArial10)
			oPrn:Say(nLin,2270,aDados[I][10][N][8],oArial10)
			oPrn:Say(nLin,2760,aDados[I][10][N][9],oArial10)  
			
			nLin += 50
//--------------------------------------------------------------			
If nLin > 1830
	oPrn:EndPage()
	meucabec()
	nLin := 560
Endif
//--------------------------------------------------------------			
			
			//nLin += 50
		Next
		nLin := 560
		xrodape()
	Next
	
	oPrn:Preview()
Return

Static Function Quebra()
	Local nMax := 0
	Local cString := AllTrim(cObs)
	Local nI := 0
	Local nF := 130
	Local aRet := {}
	
	For nMax := 1 to 2
		aadd(aRet, substr(cString,nI, nF))
		nI := 131
		nF := 130
	Next
Return aRet 


Static function meucabec()
	Local nCont := 0
	Local nLin := 300
	Local nLObs := 200   
   
   nPag++
	oPrn:StartPage()
	oPrn:SayBitmap(0035,0050,"lgrl01.bmp",200,)
	oPrn:Say(0100,0850,"RELATRIO PEDIDO DE VENDA COM ESTOQUE LIBERADO",oArial20B)
	oPrn:Say(0080,2667,"DATA:",oArial12)
	oPrn:Say(0080,2760,cData,oArial12)
	oPrn:Say(0110,2667,"HORA:",oArial12)
	oPrn:Say(0110,2760,cTime,oArial12)
	oPrn:Say(0140,2667,"PAGINA:",oArial12)
	oPrn:Say(0140,2780,cvaltochar(nPag),oArial12)
	oPrn:Line(0160,0000,0160,3000)
	   //************************CABECALHO PEDIDO *****************************
	oPrn:Say(0200,0050,"Filial :",oArial10b)
	oPrn:Say(0200,0170,Filial,oArial10)
	
	oPrn:Say(0250,0050,"Pedido :",oArial10b)
	oPrn:Say(0250,0170,Pedido,oArial10)
	
	oPrn:Say(0300,0050,"Cliente :",oArial10b)
	oPrn:Say(0300,0170,Cliente,oArial10)
			
	oPrn:Say(0350,0050,"Loja :",oArial10b)
	oPrn:Say(0350,0170,Loja,oArial10)
	
	oPrn:Say(0400,0050,"Nome :",oArial10b)
	oPrn:Say(0400,0170,Nome,oArial10)
		
	oPrn:Say(0450,0050,"Data da Liberao :",oArial10b)
	oPrn:Say(0450,0300,DataLib,oArial10)
		
	oPrn:Say(0200,1000,"Obs.Exped. :",oArial10b)

	For I := 1 to Len(aObs)
		oPrn:Say(nLObs,1167,aObs[I],oArial10)
		nLObs += 50
	Next
 
	oPrn:Line(0500,0000,0500,3000)
Return                  

Static Function xrodape()
	nLinp:=50
	nlin := 1830 +nLinp+70
	oPrn:Box( nlin-70, 0050, nlin+460,nColMax)
	oPrn:Say( nlin, 0100, "Transportadora: " ,oArial20B,100 )
	oPrn:Say( nlin, 0440, Transp ,oArial20,100 )
	nlin := nlin+20 +nLinp

	oPrn:Say( nlin, 0100, "Motorista :_____________________________________________________" ,oArial20B,100 )
	nlin := nlin+20 +nLinp


	oPrn:Say( nlin, 0100, "Placa :__________________________________________ UF:___________" ,oArial20B,100 )
	nlin := nlin+20 +nLinp

	oPrn:Say( nlin, 0100, "Peso Bruto:____________________ Peso Lquido:____________________" ,oArial20B,100 )
	nlin := nlin+20 +nLinp


	oPrn:Say( nlin, 0100, "Nota Fiscal n :________________________ " ,oArial20B,100 )
	oPrn:Say( nlin, 1030, "Frete :" ,oArial20B,100 )
	oPrn:Say( nlin, 1170, Frete ,oArial20B,100 )
	nlin := nlin+20 +nLinp

	oPrn:Say( nlin, 0100, "Hora:________________",oArial20B,100 )
	nlin := nlin+20 +nLinp

	oPrn:Say( nlin, 0100, "DATA:_____/____/_____ ",oArial20B,100 )
	nlin := nlin+20 +nLinp
                     
	oPrn:EndPage()
	

Return 


//----------------------------------------------------------------------------------------------------------------//
// Parametros que devem ser passados para a funo de criao das perguntas no arquivo SX1.
//----------------------------------------------------------------------------------------------------------------//
//  1o. Parametro -> Nome do grupo
//  2o. Parametro -> Numero da ordem
//  3o. Parametro -> Texto da pergunta em portugues
//  4o. Parametro -> Texto da pergunta em espanhol
//  5o. Parametro -> Texto  da pergunta em ingles
//  6o. Parametro -> Nome da variavel
//  7o. Parametro -> Tipo do dado C=caractere, D=Data, N=Numerico
//  8o. Parametro -> Tamanho do dado
//  9o. Parametro -> Quantidade de casas decimais para o dado
// 10o. Parametro -> Numero da pre-selecao
// 11o. Parametro -> O tipo do dado sera G=get, S=scroll, C=choice, R=Range
// 12o. Parametro -> Sintaxe em advpl, ou funcao para validacao
// 13o. Parametro -> Consistencia com alguma tabela do sistema via <F3>
// 14o. Parametro -> Nome do grupo para SXG
// 15o. Parametro -> Pyme
// 16o. Parametro -> Nome da variavel que ser utilizada no programa
// 17o. Parametro -> Primeira definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 18o. Parametro -> Primeira definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 19o. Parametro -> Primeira definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 20o. Parametro -> Conteudo da ultima resposta informada no parametro se caso o tipo do dados for get
// 21o. Parametro -> Segunda definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 22o. Parametro -> Segunda definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 23o. Parametro -> Segunda definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 24o. Parametro -> Terceira definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 25o. Parametro -> Terceira definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 26o. Parametro -> Terceira definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 27o. Parametro -> Quarta definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 28o. Parametro -> Quarta definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 29o. Parametro -> Quarta definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 30o. Parametro -> Quinta definicao do texto em portugues se caso o tipo do dado for choice, exemplo: SIM ou Nao
// 31o. Parametro -> Quinta definicao do texto em espanhol se caso o tipo do dado for choice, exemplo: Si o No
// 32o. Parametro -> Quinta definicao do texto em ingles se caso o tipo do dado for choice, exemplo: Yes or No
// 33o. Parametro -> Vetor com o texto do help em portugues
// 34o. Parametro -> Vetor com o texto do help em espanhol
// 35o. Parametro -> Vetor com o texto do help em ingles
// 36o. Parametro -> Nome do grupo do help
Static Function CriaSX1(cPerg)
	Local aHelp := {}
	//Texto do help em portugus                , ingls, espanhol
	AAdd(aHelp, {{"Informe o Nmero do Pedido"             }, {""}, {""}})
	AAdd(aHelp, {{"Informe o Numero da Loja"               }, {""}, {""}})
	AAdd(aHelp, {{"Informe o Numero do Produto"            }, {""}, {""}})
	AAdd(aHelp, {{"Informe a data inicial"                 }, {""}, {""}})
	AAdd(aHelp, {{"Informe a data final"                   }, {""}, {""}})
	AAdd(aHelp, {{"Informe Cdigo do Cliente"              }, {""}, {""}})
        
	//	  	  1o  2o     3o           4  5   6o      7  8  9  10 11  12  13   14 15    16      17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32   33           34         35     36 
	PutSX1(cPerg,"01","Pedido de?"	,"","","mv_ch1","C",06,00,00,"G","","SC5","","","mv_Par01","","","","","","","","","","","","","","","","",aHelp[1,1],aHelp[1,2],aHelp[1,3],"")
	PutSX1(cPerg,"02","Pedido at"  ,"","","mv_ch2","C",06,00,00,"G","","SC5","","","mv_Par02","","","","","","","","","","","","","","","","",aHelp[1,1],aHelp[1,2],aHelp[1,3],"")
	PutSX1(cPerg,"03","Cliente de?"	,"","","mv_ch3","C",06,00,00,"G","","SA1","","","mv_Par03","","","","","","","","","","","","","","","","",aHelp[6,1],aHelp[6,2],aHelp[6,3],"")
	PutSX1(cPerg,"04","Loja de?"	,"","","mv_ch4","C",02,00,00,"G","","","","","mv_Par04","","","","","","","","","","","","","","","","",aHelp[2,1],aHelp[2,2],aHelp[2,3],"")
	PutSX1(cPerg,"05","Cliente at" ,"","","mv_ch5","C",06,00,00,"G","","SA1","","","mv_Par05","","","","","","","","","","","","","","","","",aHelp[6,1],aHelp[6,2],aHelp[6,3],"")
	PutSX1(cPerg,"06","at Loja" ,"","","mv_ch6","C",02,00,00,"G","","","","","mv_Par06","","","","","","","","","","","","","","","","",aHelp[2,1],aHelp[2,2],aHelp[2,3],"")
	PutSX1(cPerg,"07","Produto de?"	,"","","mv_ch7","C",15,00,00,"G","","SB1ATF","","","mv_Par07","","","","","","","","","","","","","","","","",aHelp[1,1],aHelp[1,2],aHelp[1,3],"")
	PutSX1(cPerg,"08","Produto at" ,"","","mv_ch8","C",15,00,00,"G","","SB1ATF","","","mv_Par08","","","","","","","","","","","","","","","","",aHelp[3,1],aHelp[3,2],aHelp[3,3],"")
	PutSX1(cPerg,"09","Data de?" 	,"","","mv_ch9","D",08,00,00,"G","","   ","","","mv_Par09","","","","","","","","","","","","","","","","",aHelp[4,1],aHelp[4,2],aHelp[4,3],"")
	PutSX1(cPerg,"10","Data ate?" 	,"","","mv_ch10","D",08,00,00,"G","","   ","","","mv_Par10","","","","","","","","","","","","","","","","",aHelp[5,1],aHelp[5,2],aHelp[5,3],"")
 Return 
 
